## magics++ 2.24.7

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# TODO:
#  * fix python module generation Magics.py to __init__.py
#  * cpack ecbuild/cmake macros into tar.gz
#  * unit tests check that certain files are produced and not empty
#  * pkg-config needed for metview

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.4 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(MAGICS_INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system )

ecbuild_requires_macro_version( 1.2 )

###############################################################################
# some variables of this project

option( ENABLE_GRIB           "enable grib support"               ON  )
option( ENABLE_NETCDF         "enable netcdf support"             ON  )

option( ENABLE_ODB            "enable odb"                        OFF )
option( ENABLE_BUFR           "enable bufr support"               OFF )
option( ENABLE_SPOT           "enable spot support"               OFF )
option( ENABLE_CAIRO          "enable cairo support[png/jpeg]"    OFF )
option( ENABLE_GEOTIFF        "enable geotiff support [implies cairo]" OFF )

option( ENABLE_PYTHON         "enable python interface"   ON  )
option( ENABLE_FORTRAN        "enable fortran interface"  ON  )

option( ENABLE_METVIEW        "enable Metview interface"  OFF  )
option( ENABLE_METVIEW_NO_QT  "enable Metview interface without Qt"    OFF )

option( ENABLE_STATIC_LIBRARY    "Internal Build static Library"    OFF  )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

# Regression definitions
set( MAGICS_REFERENCE_VERSIONS            "2.24.5" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

### fortran

if( ENABLE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

### python

if( ENABLE_PYTHON )
	ecbuild_find_python( REQUIRED )

    debug_var( PYTHON_INCLUDE_DIRS )
    debug_var( PYTHON_LIBRARIES )

    if( NOT PYTHON_INCLUDE_DIRS OR NOT PYTHON_LIBRARIES )
        message( FATAL_ERROR "Couldn't find Python libraries" )
    endif()

	find_package( SWIG REQUIRED )
	find_package( NumPy REQUIRED )
endif()
if( SWIG_FOUND )
   include(UseSWIG)
endif()

### grib
#cmake_add_cxx_flags("-gdwarf-2")

set( grib no )
if( ENABLE_GRIB )
  ecbuild_use_package( PROJECT grib_api VERSION 1.9 REQUIRED)
endif()
if( GRIB_API_FOUND )
   set( MAGICS_GRIB 1 )
   set( grib yes )
endif()

### netcdf

set( netcdf no )
# set( PREFER_NETCDF4 1)
# set( NETCDF_CXX 1 )
if ( ENABLE_NETCDF )
  find_package( NetCDF 4 COMPONENTS C CXX REQUIRED)
endif()
if ( NETCDF_FOUND )
    list( APPEND MAGICS_TPLS  NetCDF )
    set(MAGICS_NETCDF 1)
	set( netcdf yes)
endif()

### odb

set( odb no )
if( ENABLE_ODB )
  ecbuild_use_package( PROJECT odb_api  VERSION 0.10.2 REQUIRED)
endif()
if( ODB_API_FOUND )

    get_filename_component( odb_api_install_dir ${ODB_API_CMAKE_DIR}/../../../lib ABSOLUTE )
    get_filename_component( eckit_install_dir   ${ECKIT_CMAKE_DIR}/../../../lib ABSOLUTE )

      set( MAGICS_ODB 1 )
	  set( odb yes)

	  # does this version use eckit?
	  list(FIND ODB_API_LIBRARIES eckit ODB_ECKIT_INDEX)

    if (NOT ODB_ECKIT_INDEX EQUAL -1)  # is an eckit version
        add_definitions(-DODB_ECKIT)
    endif()

endif()

### spot

set( spot no )
if( ENABLE_SPOT )
    ecbuild_use_package( PROJECT spot  REQUIRED)
    if( SPOT_FOUND )
        set (MAGICS_SPOT 1)
        set ( spot yes)
    endif()
else() 
endif()

### bufr

set( bufr no )
if( ENABLE_BUFR )
  find_package( EMOS REQUIRED )
endif()
if( EMOS_FOUND )
   set( MAGICS_BUFR 1 )
   set( bufr yes)
endif()


### cairo

set( cairo no )
if( ENABLE_CAIRO )
	find_package( PangoCairo REQUIRED )
else()
    find_package( PangoCairo )
endif()
    
if( PANGOCAIRO_FOUND )
	set( MAGICS_CAIRO 1 )
	set( cairo yes )
	if( ENABLE_GEOTIFF )
	   find_package( GeoTIFF REQUIRED )
	   if( GEOTIFF_FOUND )
	      set( MAGICS_GEOTIFF 1 )
	   endif()
	endif()
endif()


### Metview and Qt

if(ENABLE_METVIEW AND ENABLE_METVIEW_NO_QT)
    message(FATAL_ERROR "Do not set both ENABLE_METVIEW and ENABLE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( qtlib no )
set( metview no )

if( ENABLE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( ENABLE_METVIEW )
    set ( metview yes)
    unset(MAGICS_ONLY)
    find_package(Qt4 4.4.3 REQUIRED QtCore QtGui QtXml )
    if( QT_FOUND )
		  include( ${QT_USE_FILE} )
		  set( MAGICS_QT 1)
		  set( qt yes)
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads ) 

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.49.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT  REQUIRED )


install( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics-config
			DESTINATION ${INSTALL_BIN_DIR} 
			PERMISSIONS OWNER_READ GROUP_READ WORLD_READ 
				        OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)


###############################################################################
# contents

set( MAGICS_TPLS grib_api spot odb_api EXPAT NetCDF PangoCairo Proj4 EMOS)
set( MAGICS_INCLUDE_DIRS 
	    ${CMAKE_CURRENT_SOURCE_DIR}/src 
        ${CMAKE_BINARY_SOURCE_DIR}/src 
        ${CMAKE_CURRENT_SOURCE_DIR}/src/common 
        ${CMAKE_CURRENT_BINARY_DIR}/src/params 
        ${CMAKE_CURRENT_BINARY_DIR}/src 
        ${CMAKE_CURRENT_SOURCE_DIR}/src/common  
        ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
        ${CMAKE_CURRENT_SOURCE_DIR}/src/web
        ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
        ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
        ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
        ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
        ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
        ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
        ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
        ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/utils
	    ${Boost_INCLUDE_DIRS} )
	    
if( MAGICS_ODB )
    list( APPEND MAGICS_INCLUDE_DIRS
			${CMAKE_CURRENT_SOURCE_DIR}/src/oda 
			${ODB_API_INCLUDE_DIRS}/../eclib 
		)
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
endforeach()

if( MAGICS_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()

if( MAGICS_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
	list( APPEND MAGICS_EXTRA_DEFINITIONS MAGICS_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

message(STATUS "MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
message(STATUS "MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
message(STATUS "MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")



# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

set(  __magics_inc_tmp ${MAGICS_EXTRA_INCLUDE_DIRS} )
set(MAGICS_EXTRA_INCLUDES "")

foreach( inc ${__magics_inc_tmp} ) 
  set(MAGICS_EXTRA_INCLUDES "${MAGICS_EXTRA_INCLUDES} -I${inc}" )
endforeach()

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface 
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources 
		DONT_PACK_DIRS tools/versioncmp 
					tools/regression 
                    regression
                    docs
                    toolsjs
                    test/old
					tools/xml 
					tools/use_scripts
					tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal 
		DONT_PACK configure.lxab
                    configure.local
                    configure.ecgb
                    configure.ecmwf
					)


set(  __magics_tmp ${MAGICS_EXTRA_LIBRARIES} )

list(REMOVE_ITEM __magics_tmp debug )
list(REMOVE_ITEM __magics_tmp optimized )
if( ODB_API_FOUND )
    list(REMOVE_ITEM __magics_tmp Odb)
    list(REMOVE_ITEM __magics_tmp eckit)
    list(REMOVE_ITEM __magics_tmp eckit_web)
    list(REMOVE_ITEM __magics_tmp eckit_geometry)
endif()

set(MAGICS_EXTRA_LIBS "")

foreach( lib ${__magics_tmp} )
  if( lib MATCHES "^/.*" )
# Need to split -L/path and -l libd
	
	 get_filename_component(ext ${lib} EXT)
	  if ( ${ext} MATCHES ${CMAKE_SHARED_LIBRARY_SUFFIX} )
		
		get_filename_component(path ${lib} PATH)
		
		list( APPEND RPATH "-Wl,-rpath,${path}")
	  endif()
	 
  else()
    if( NOT lib MATCHES "^-l.*" )
		set( lib "-l${lib}" )
	endif()
  endif()
  
  set(MAGICS_EXTRA_LIBS "${MAGICS_EXTRA_LIBS} ${lib}" )
endforeach()


set(MAGICS_RPATH " -Wl,-rpath,${CMAKE_INSTALL_PREFIX}/lib" )

if( ODB_API_FOUND )

    set(MAGICS_EXTRA_LIBS "${MAGICS_EXTRA_LIBS} -L${odb_api_install_dir} -lOdb")
    set(MAGICS_EXTRA_LIBS "${MAGICS_EXTRA_LIBS} -L${eckit_install_dir} -leckit")
    set(MAGICS_EXTRA_LIBS "${MAGICS_EXTRA_LIBS} -L${eckit_install_dir} -leckit_web")
    set(MAGICS_EXTRA_LIBS "${MAGICS_EXTRA_LIBS} -L${eckit_install_dir} -leckit_geometry")
    set(MAGICS_RPATH "${MAGICS_RPATH}  -Wl,-rpath,${eckit_install_dir}" ) 
    set(MAGICS_RPATH "${MAGICS_RPATH}  -Wl,-rpath,${odb_api_install_dir}" )
endif()




list(REMOVE_DUPLICATES RPATH)

foreach( path ${RPATH} )
	set(MAGICS_RPATH "${MAGICS_RPATH} ${path}" )
endforeach()

debug_var(MAGICS_RPATH)
	

configure_file( magics-config.in  magics-config @ONLY )

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )
configure_file( magics.pc.in  magics.pc @ONLY  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})
install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics.pc      DESTINATION ${INSTALL_LIB_DIR}/pkgconfig)

###############################################################################


function( add_metview_definition_file )
   
    set( single_value_args ACTION BASENAME FILE ) 
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )
     
    add_custom_command( 
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )
     
     
    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)

add_subdirectory( params )



foreach( file ${magics_xmls} )

      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${path}/${basefile}Attributes.h ${path}/${basefile}Attributes.cc )
      
      # generate the code
      add_custom_command( 
            OUTPUT  ${ouputfiles}
            COMMAND ${PERL_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/xml2cc_new.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
            DEPENDS ${file}
      )

      set_source_files_properties( ${basefile}Attributes.h  GENERATED )
      set_source_files_properties( ${basefile}Attributes.cc GENERATED )

      list( APPEND magics_params_srcs ${ouputfiles} )

endforeach()
     
if ( metview )

      
	foreach( file ${metview_xmls} )
	      get_filename_component( path     ${file} PATH   )
          get_filename_component( basefile ${file} NAME_WE )
		  
		  set( metviewfiles ${path}/${basefile}Wrapper.h ${path}/${basefile}Wrapper.cc )
		  
		  
		# generate the code
		  add_custom_command( 
				OUTPUT  ${metviewfiles}
				COMMAND ${PERL_EXECUTABLE} ${CMAKE_SOURCE_DIR}/tools/xml2mv.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
				DEPENDS ${file}
			)

		  set_source_files_properties( ${basefile}Wrapper.h  GENERATED )
          set_source_files_properties( ${basefile}Wrapper.cc GENERATED )
          list( APPEND metview_wrappers_srcs ${metviewfiles} )
      endforeach()

     if(qt)
        SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
        QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
     endif()

endif()
	 






add_custom_target( magics_params DEPENDS ${magics_params_srcs} )
add_custom_target( mv_params DEPENDS ${metview_wrappers_srcs} )
###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( MAGICS_ODB )
	add_subdirectory( oda )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/common )

ecbuild_add_library( TARGET    MagPlusShared
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS} MAGICS_EXCEPTION=on
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
		            TYPE SHARED		     
                    )

ecbuild_add_library( TARGET    MagPlusSingleShared 
		     SOURCES MagicsSingle.cc
             LIBS MagPlusShared
		     TYPE SHARED)
		     
ecbuild_add_library(TARGET    MagPlusDoubleShared 
             LIBS MagPlusShared
		     SOURCES MagicsDouble.cc
		     TYPE SHARED)		     

SET_TARGET_PROPERTIES(MagPlusShared PROPERTIES OUTPUT_NAME "MagPlus")
SET_TARGET_PROPERTIES(MagPlusDoubleShared PROPERTIES OUTPUT_NAME "MagPlusDouble")
SET_TARGET_PROPERTIES(MagPlusSingleShared PROPERTIES OUTPUT_NAME "MagPlusSingle")




if ( ENABLE_STATIC_LIBRARY ) 	     
ecbuild_add_library( TARGET    MagPlusStatic
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}  
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES} 
		            TYPE STATIC		     
                    )
ecbuild_add_library( TARGET    MagPlusSingleStatic 
		     SOURCES MagicsSingle.cc
		     INCLUDES  ${CMAKE_CURRENT_SOURCE_DIR}/common
		     TYPE SHARED)
		     
ecbuild_add_library(TARGET    MagPlusDoubleStatic 
		     SOURCES MagicsDouble.cc
		     INCLUDES  ${CMAKE_CURRENT_SOURCE_DIR}/common
		     TYPE SHARED)

    SET_TARGET_PROPERTIES(MagPlusStatic PROPERTIES OUTPUT_NAME "MagPlus")
    SET_TARGET_PROPERTIES(MagPlusDoubleStatic PROPERTIES OUTPUT_NAME "MagPlusDouble")
    SET_TARGET_PROPERTIES(MagPlusSingleStatic PROPERTIES OUTPUT_NAME "MagPlusSingle")

endif()

if( metview )
 include_directories(  ${CMAKE_CURRENT_SOURCE_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR}/params 
                        ${CMAKE_CURRENT_SOURCE_DIR}/common  
                        ${CMAKE_CURRENT_SOURCE_DIR}/basic
                        ${CMAKE_CURRENT_SOURCE_DIR}/web
                        ${CMAKE_CURRENT_SOURCE_DIR}/visualisers
                        ${CMAKE_CURRENT_SOURCE_DIR}/drivers
                        ${CMAKE_CURRENT_SOURCE_DIR}/decoders
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/kernel
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/utils 
                        ${CMAKE_CURRENT_SOURCE_DIR}/libMagWrapper )
                        
  ecbuild_add_library( TARGET    MagWrapper
                     DEPENDS   mv_params magics_params
                     SOURCES
                        magics.h
                        ${metview_srcs} 
                        ${metview_wrappers_srcs} 
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}                   
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                    TYPE STATIC		
                    )
   list( APPEND attributes_include
				OutputHandlerAttributes.h 
				FortranRootSceneNodeAttributes.h  
                BinningObjectAttributes.h
                GribDecoderAttributes.h
                DateGribLoopStepAttributes.h
                GribLoopAttributes.h
                GeoRectangularProjectionAttributes.h
                LegendVisitorAttributes.h
				XmlRootNodeAttributes.h 
				WrepRootNodeAttributes.h
				QtDriverAttributes.h
                ContinuousLegendMethodAttributes.h
                HistogramLegendMethodAttributes.h
                XmlBasicNodeAttributes.h
                ImagePlottingAttributes.h
                LookupTableModeAttributes.h
                FixedTableModeAttributes.h

				)
   install( FILES terralib/kernel/TeProjection.h
				   terralib/kernel/TeCoord2D.h 
				   terralib/kernel/TeDefines.h 
				   terralib/kernel/TePrecision.h 
				   terralib/kernel/TeSingleton.h 
				   terralib/kernel/TeDatum.h 
				   terralib/kernel/TeUtils.h
				   terralib/kernel/TeProgress.h
				   terralib/kernel/TeProgressBase.h
				   
				   
				   DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES VectorOfPointers.h  DESTINATION ${INSTALL_INCLUDE_DIR})
   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_BINARY_DIR}/params/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()
install( FILES magics.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== test/CMakeLists.txt ===



# Basic test 
ecbuild_add_test( TARGET basic_c
            SOURCES   coast.c
            LIBS      MagPlusSingleShared MagPlusShared
            ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
            LINKER_LANGUAGE C )


if ( ENABLE_PYTHON )
   ecbuild_add_test( TARGET basic_python
              TYPE PYTHON
              ARGS coast.py
              RESOURCES coast.py 
              ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} MAGPLUS_HOME=${CMAKE_SOURCE_DIR} )
endif()

if ( ENABLE_FORTRAN) 
    ecbuild_add_test( TARGET basic_fortran_shared
            SOURCES   coast.f90
            LIBS      MagPlusSingleShared MagPlusShared
            ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
            LINKER_LANGUAGE Fortran )
    if ( ENABLE_STATIC_LIBRARY )
        ecbuild_add_test( TARGET basic_fortran_static
            SOURCES   coast.f90
            LIBS      MagPlusSingleStatic MagPlusStatic ${MAGICS_EXTRA_LIBRARIES} 
            ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
            LINKER_LANGUAGE Fortran )       
     endif()
endif()
    
if ( ENABLE_BUFR )
    if ( ENABLE_PYTHON )
       ecbuild_add_test( TARGET bufr_python
                  TYPE PYTHON
                  ARGS bufr.py
                  RESOURCES bufr.py data.bufr 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} MAGPLUS_HOME=${CMAKE_SOURCE_DIR})
    endif()
    if ( ENABLE_FORTRAN) 
        ecbuild_add_test( TARGET bufr_fortran
                SOURCES   bufr.f90
                LIBS      MagPlusSingleShared MagPlusShared
                RESOURCES data.bufr
                LINKER_LANGUAGE Fortran 
                ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR})
        if ( ENABLE_STATIC_LIBRARY )
             ecbuild_add_test( TARGET bufr_fortran_static
                    SOURCES   bufr.f90
                    RESOURCES data.bufr
                    LIBS      MagPlusSingleStatic MagPlusStatic
                    ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
                    LINKER_LANGUAGE Fortran )       
         endif()
    endif()
endif()




if ( ENABLE_GRIB )
    if ( ENABLE_PYTHON )
       ecbuild_add_test( TARGET grib_python
                  TYPE PYTHON
                  ARGS grib.py
                  RESOURCES grib.py data.grib
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}  MAGPLUS_HOME=${CMAKE_SOURCE_DIR})
    endif()
    if ( ENABLE_FORTRAN) 
        ecbuild_add_test( TARGET grib_fortran
                SOURCES   grib.f90
                LIBS      MagPlusSingleShared MagPlusShared
                RESOURCES data.grib
                ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
                LINKER_LANGUAGE Fortran )
    endif()
endif()



if ( ENABLE_CAIRO ) 
    if ( ENABLE_PYTHON )
        ecbuild_add_test( TARGET cairo_python
                  TYPE PYTHON
                  ARGS cairo.py
                  RESOURCES cairo.py 
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH}  MAGPLUS_HOME=${CMAKE_SOURCE_DIR})
    endif()
      if ( ENABLE_FORTTAN )
        ecbuild_add_test( TARGET cairo_fortran
                SOURCES   cairo.f90
                LIBS      MagPlusSingleShared MagPlusShared
                ENVIRONMENT MAGPLUS_HOME=${CMAKE_SOURCE_DIR}
                LINKER_LANGUAGE Fortran )
    endif()
endif()

if ( ENABLE_ODB )
    if ( ENABLE_PYTHON )
        ecbuild_add_test( TARGET odb_python
                  TYPE PYTHON
                  ARGS odb.py
                  RESOURCES odb.py test.odb
                  ENVIRONMENT PYTHONPATH=${MAG_PYTHON_PATH} MAGPLUS_HOME=${CMAKE_SOURCE_DIR} )
    endif()
endif()

=== debian/changelog ===
magics++ (2.24.7-7) unstable; urgency=medium

  * ABI transition needed for libstdc++ v5, to libmagplus3v5. 
    Closes: #797981. 
  * Add Breaks/Replaces libmagplus3

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 11 Sep 2015 11:52:41 +0100

magics++ (2.24.7-6) unstable; urgency=medium

  * Add dependency on libnetcdf-cxx-legacy-dev.
  * Replace B-D libgd2-dev -> libgd-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 14 Aug 2015 09:53:25 +0100

magics++ (2.24.7-5) unstable; urgency=medium

  * Rebuild against libterralib3 for terralib, g++5 transitions.
  * Undo the netcdf transition for the moment
  * Move Qt4 -> Qt5 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 07 Aug 2015 13:28:04 +0100

magics++ (2.24.7-4) experimental; urgency=medium

  * Build against new netcdf (4.4.0). Closes: #793882.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 13:32:09 +0100

magics++ (2.24.7-3) experimental; urgency=medium

  * Build against new netcdf (4.4.0). Closes: #793882.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Jul 2015 13:32:09 +0100

magics++ (2.24.7-2) unstable; urgency=medium

  * Drop timestamps from headers. Closes: #792824. 
  * Add magics++ to dependencies for libmagics++-dev, add metgramx etc
    as required by magics-config.cmake for metview
  * Undo fixes from debian/rules for previously broken builds in 2.24.4
  * Move cmake files to /usr/lib/$ARCH/cmake as arch-dependent,
    and adjust paths in cmake files vi debian/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Jul 2015 19:36:10 +0100

magics++ (2.24.7-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 16 Jul 2015 08:55:06 +0100

magics++ (2.24.4-2) experimental; urgency=medium

  * Test Build against netcdf 4.4.3 in experimental 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jul 2015 16:48:32 +0100

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 9) , dh-buildinfo, gfortran, cmake, chrpath,
 dh-python,
 libhdf5-serial-dev | libhdf5-dev, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev, 
 libgrib-api-dev, libgrib-api-tools,
 libterralib-dev, 
 libjasper-dev, libcairo2-dev, libpango1.0-dev,
 ttf-dejavu-core, libxml-parser-perl, 
 python-all-dev, swig, python-numpy, python-instant,
 libopenjpeg-dev, ghostscript, zlib1g-dev, libboost-dev, libproj-dev, 
 qt5-default, qtbase5-dev
Standards-Version: 3.9.6
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Breaks: libmagplus3
Replaces: libmagplus3
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, libterralib-dev, magics++
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh,
 ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python, python-simplejson
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

=== debian/rules ===
#!/usr/bin/make -f

BUILDDIR = $(CURDIR)/debian/build

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@  --with python2 --with-buildsystem=cmake --builddirectory=$(BUILDDIR)

export extra_flags += \
	-DBUILD_SITE=debian \
	-DHAVE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBGRIB_API=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_QT=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=OFF \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd'

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure -- $(extra_flags)
	(cd python/Magics && ln -s $(BUILDDIR)/python/Magics/Magics.i )

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(shell pwd)/swig ; export MAGPLUS_HOME=$(shell pwd) ; $(MAKE) check )

override_dh_auto_install:
	$(MAKE) -C debian/build/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python2.7 \
			DESTDIR=$(CURDIR)/debian/python-magics++ \ MAGPLUS_HOME=$(CURDIR) 
	dh_auto_install
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_numpy -p python-magics++
	find debian/tmp debian/python-magics++  -name '*.so*' -exec chrpath -d {} \;
	find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
